const { get } = require('node-superfetch');
const chalk = require('chalk');
const { version } = require('../../package.json');

/**
* @class NSFW
*/
class NSFW {
	constructor(token, baseURL) {
		/**
         * Your Lunar API Token.
         * @type {string}
         * @private
        */
		this.token = token;

		/**
          * The base URL.
          * @type {string}
          * @private
         */
		this.baseURL = baseURL;
	}

	/**
      * Returns a random GIF under the 'ahegao' endpoint.
	  * @param {boolean} getId - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The Formatted GIF URL. (Or ID if getId is true)
      */
	async ahegao(getId) {
		try {
			const { body } = await get(`${this.baseURL}/ahegao`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAP » v${version}`);
			if (getId) {
				return body.id;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAP')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'ass' endpoint.
	  * @param {boolean} getId - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The Formatted GIF URL. (Or ID if getId is true)
      */
	async ass(getId) {
		try {
			const { body } = await get(`${this.baseURL}/ass`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAP » v${version}`);
			if (getId) {
				return body.id;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAP')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'cum' endpoint.
	  * @param {boolean} getId - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The Formatted GIF URL. (Or ID if getId is true)
      */
	async cum(getId) {
		try {
			const { body } = await get(`${this.baseURL}/cum`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAP » v${version}`);
			if (getId) {
				return body.id;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAP')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'boobs' endpoint.
	  * @param {boolean} getId - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The Formatted GIF URL. (Or ID if getId is true)
      */
	async boobs(getId) {
		try {
			const { body } = await get(`${this.baseURL}/boobs`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAP » v${version}`);
			if (getId) {
				return body.id;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAP')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'gif' endpoint.
	  * @param {boolean} getId - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The Formatted GIF URL. (Or ID if getId is true)
      */
	async gif(getId) {
		try {
			const { body } = await get(`${this.baseURL}/gif`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAP » v${version}`);
			if (getId) {
				return body.id;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAP')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'hololive' endpoint.
	  * @param {boolean} getId - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The Formatted GIF URL. (Or ID if getId is true)
      */
	async hololive(getId) {
		try {
			const { body } = await get(`${this.baseURL}/hololive`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAP » v${version}`);
			if (getId) {
				return body.id;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAP')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'jpg' endpoint.
	  * @param {boolean} getId - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The Formatted GIF URL. (Or ID if getId is true)
      */
	async jpg(getId) {
		try {
			const { body } = await get(`${this.baseURL}/jpg`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAP » v${version}`);
			if (getId) {
				return body.id;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAP')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'neko' endpoint.
	  * @param {boolean} getId - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The Formatted GIF URL. (Or ID if getId is true)
      */
	async neko(getId) {
		try {
			const { body } = await get(`${this.baseURL}/neko`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAP » v${version}`);
			if (getId) {
				return body.id;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAP')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'panties' endpoint.
	  * @param {boolean} getId - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The Formatted GIF URL. (Or ID if getId is true)
      */
	async panties(getId) {
		try {
			const { body } = await get(`${this.baseURL}/panties`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAP » v${version}`);
			if (getId) {
				return body.id;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAP')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'thighs' endpoint.
	  * @param {boolean} getId - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The Formatted GIF URL. (Or ID if getId is true)
      */
	async thighs(getId) {
		try {
			const { body } = await get(`${this.baseURL}/thighs`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAP » v${version}`);
			if (getId) {
				return body.id;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAP')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}

	/**
      * Returns a random GIF under the 'yuri' endpoint.
	  * @param {boolean} getId - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The Formatted GIF URL. (Or ID if getId is true)
      */
	async yuri(getId) {
		try {
			const { body } = await get(`${this.baseURL}/yuri`)
				.set('Authorization', `Bearer ${this.token}`)
				.set('User-Agent', `LunarAP » v${version}`);
			if (getId) {
				return body.id;
			}
			else {
				return body.url;
			}
		}
		catch (e) {
			throw new Error(`${chalk.magenta('LunarAP')} ${chalk.gray('»')} ${chalk.red(`An unknown error has occured!:\n\n${e}`)}`);
		}
	}
}

module.exports = NSFW;