export = SFW;
/**
* @class SFW
*/
declare class SFW {
    constructor(token: any, baseURL: any);
    /**
     * Your Lunar API Token.
     * @type {string}
     * @private
    */
    private token;
    /**
      * The base URL.
      * @type {string}
      * @private
     */
    private baseURL;
    /**
      * Returns a random GIF under the 'hug' endpoint.
      * @param {boolean} getId - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The Formatted GIF URL. (Or ID if getId is true)
      */
    hug(getId: boolean): Promise<string>;
    /**
      * Returns a random GIF under the 'pat' endpoint.
      * @param {boolean} getId - Whether to return the Image ID instead of the image URL.
      * @returns {Promise<string>} The Formatted GIF URL. (Or ID if getId is true)
      */
    pat(getId: boolean): Promise<string>;
}
